## dde-control-center 5.5.144

=== abrecovery/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION 4.0)

set(BIN_NAME abrecovery)
set(FILES_NAME deepin-ab-recovery.desktop)

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
endif()

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(SRCS
    main.cpp
    recoverydialog.h
    recoverydialog.cpp
    backgroundwidget.h
    backgroundwidget.cpp
    deepin-ab-recovery.desktop
)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

add_executable(${BIN_NAME} ${SRCS})
target_include_directories(${BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
)

# bin
install(TARGETS ${BIN_NAME} DESTINATION /usr/bin)
install(FILES ${FILES_NAME} DESTINATION /etc/xdg/autostart)

=== src/frame/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION 4.0)

set(BIN_NAME dde-control-center)

# set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall -Wl,--as-needed -fPIE")

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
endif()

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(DEFINED_LIST
DISABLE_OPACITY_ANIMATION
DISABLE_CLOUD_SYNC
DISABLE_SYS_UPDATE
DISABLE_AUTHENTICATION
DISABLE_ACCOUNT
DISABLE_DISPLAY
DISABLE_DEFAULT_APPLICATIONS
DISABLE_PERSONALIZATION
DISABLE_BLUETOOTH
DISABLE_SOUND
DISABLE_DATETIME
DISABLE_POWER
DISABLE_MOUSE
DISABLE_KAYBOARD
DISABLE_WACOM
DISABLE_SYSINFO
DISABLE_SYS_UPDATE_SOURCE_CHECK
DISABLE_SYS_UPDATE_MIRRORS
DISABLE_MAIN_PAGE
DISABLE_RECOVERY
DISABLE_DEVELOPER_MODE
DCC_ENABLE_ADDOMAIN
DCC_DISABLE_KBLAYOUT
DCC_DISABLE_LANGUAGE
DCC_DISABLE_POWERSAVE
DCC_DISABLE_FEEDBACK
DCC_DISABLE_ROTATE
DCC_DISABLE_MIRACAST
DCC_DISABLE_TIMEZONE
DCC_DISABLE_GRUB
DCC_KEEP_SETTINGS_LIVE
DCC_COMMUNITY_LICENSE
)

foreach(LETTER ${DEFINED_LIST})
    if(DEFINED ${LETTER})
        add_definitions(-D${LETTER})
    endif()
endforeach()

# load files
set(FRAME_FILES
                main.cpp
                dbuscontrolcenterservice.cpp
)

set(WINDOW_FILES
    window/mainwindow.cpp
    window/utils.h
    window/gsettingwatcher.cpp
    window/gsettingwatcher.h
    window/dconfigwatcher.cpp
    window/dconfigwatcher.h
    window/accessibleinterface.h
    window/accessible.h
    window/protocolfile.cpp
    window/insertplugin.cpp
    window/insertplugin.h
    window/modules/display/displaywidget.cpp
    window/modules/datetime/datetimemodule.cpp
    window/modules/datetime/datetimewidget.cpp
    window/modules/datetime/datewidget.cpp
    window/modules/datetime/clockitem.cpp
    window/modules/datetime/clock.cpp
    window/modules/datetime/timezonelist.cpp
    window/modules/datetime/timezonecontentlist.cpp
    window/modules/datetime/systemtimezone.cpp
    window/modules/datetime/formatsetting.cpp
    window/modules/datetime/formatsetting.h
    window/modules/datetime/currencyformat.cpp
    window/modules/datetime/currencyformat.h
    window/modules/datetime/numberformat.cpp
    window/modules/datetime/numberformat.h
    window/modules/datetime/datesettings.cpp
    window/modules/datetime/timesetedit.cpp
    window/modules/datetime/datetimecombox.cpp
    window/modules/datetime/timespinbox.cpp
    window/modules/display/displaymodule.cpp
    window/modules/display/scalingwidget.cpp
    window/modules/display/resolutionwidget.cpp
    window/modules/display/brightnesswidget.cpp
    window/modules/display/rotatewidget.cpp
    window/modules/display/refreshratewidget.cpp
    window/modules/display/multiscreenwidget.cpp
    window/modules/display/secondaryscreendialog.cpp
    window/modules/touchscreen/touchscreenmodule.cpp
    window/modules/touchscreen/touchscreenwidget.cpp
    window/modules/power/powermodule.cpp
    window/modules/power/powerwidget.cpp
    window/modules/power/generalwidget.cpp
    window/modules/power/useelectricwidget.cpp
    window/modules/power/usebatterywidget.cpp
    window/modules/sound/soundwidget.cpp
    window/modules/sound/soundmodule.cpp
    window/modules/sound/speakerpage.cpp
    window/modules/sound/microphonepage.cpp
    window/modules/sound/soundeffectspage.cpp
    window/modules/sound/devicemanagespage.cpp
    window/modules/update/updatemodule.cpp
    window/modules/update/updatewidget.cpp
    window/modules/update/updatectrlwidget.cpp
    window/modules/update/updatesettings.cpp
    window/modules/update/loadingitem.cpp
    window/modules/update/updatehistorybutton.cpp
    window/modules/update/recenthistoryapplist.cpp
    window/modules/update/mirrorswidget.cpp
    window/modules/update/mirrorsourceitem.cpp
    window/search/searchwidget.cpp
    window/search/searchmodel.cpp
    window/modules/commoninfo/commoninfomodule.cpp
    window/modules/commoninfo/commoninfowidget.cpp
    window/modules/commoninfo/commoninfomodel.cpp
    window/modules/commoninfo/commoninfowork.cpp
    window/modules/commoninfo/bootwidget.cpp
    window/modules/commoninfo/commonbackgrounditem.cpp
    window/modules/commoninfo/userexperienceprogramwidget.cpp
    window/modules/wacom/wacommodule.cpp
    window/modules/wacom/wacomwidget.cpp
    window/modules/wacom/wacomworker.cpp
    window/modules/wacom/wacommodel.cpp
    window/modules/wacom/pressuresettings.cpp
    window/modules/commoninfo/developermodewidget.cpp
    window/modules/commoninfo/developermodedialog.cpp
)

if (DEFINED DISABLE_SYS_UPDATE)
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/updatemodule.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/updatewidget.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/updatectrlwidget.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/updatesettings.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/loadingitem.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/updatehistorybutton.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/recenthistoryapplist.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/mirrorswidget.cpp")
  list(REMOVE_ITEM WINDOW_FILES "window/modules/update/mirrorsourceitem.cpp")
endif()

# load interfaces
set(INTERFACES_FILES
                ../../include/interface/moduleinterface.h
                ../../include/interface/frameproxyinterface.h
)

# load widgets
set(WIDGETS_FILES
                widgets/backbutton.cpp
                widgets/basiclistdelegate.cpp
                ../../include/widgets/basiclistdelegate.h
                widgets/buttontuple.cpp
                widgets/dccslider.cpp
                ../../include/widgets/dccslider.h
                widgets/dccsliderannotated.cpp
                ../../include/widgets/dccsliderannotated.h
                ../../include/widgets/labels/largelabel.h
                ../../include/widgets/labels/normallabel.h
                ../../include/widgets/labels/smalllabel.h
                ../../include/widgets/labels/tipslabel.h
                widgets/lineeditwidget.cpp
                widgets/loadingindicator.cpp
                ../../include/widgets/loadingindicator.h
                widgets/loadingnextpagewidget.cpp
                widgets/nextbutton.cpp
                widgets/optionlistpage.cpp
                widgets/searchinput.cpp
                ../../include/widgets/searchinput.h
                widgets/separator.cpp
                ../../include/widgets/separator.h
                widgets/settingsheaderitem.cpp
                ../../include/widgets/settingsheaderitem.h
                widgets/settingsitem.cpp
                ../../include/widgets/settingsitem.h
                widgets/spinboxwidget.cpp
                ../../include/widgets/spinboxwidget.h
                widgets/buttoneditwidget.cpp
                ../../include/widgets/buttoneditwidget.h
                widgets/tipsitem.cpp
                ../../include/widgets/tipsitem.h
                widgets/titlelabel.cpp
                ../../include/widgets/titlelabel.h
                widgets/titlevalueitem.cpp
                ../../include/widgets/titlevalueitem.h
                widgets/translucentframe.cpp
                ../../include/widgets/translucentframe.h
                widgets/settingsgroup.cpp
                widgets/switchwidget.cpp
                widgets/comboxwidget.cpp
                ../../include/widgets/comboxwidget.h
                widgets/themeitempic.cpp
                ../../include/widgets/themeitempic.h
                ../../include/widgets/utils.h
                ../../include/widgets/backbutton.h
                widgets/basiclistmodel.cpp
                ../../include/widgets/basiclistmodel.h
                widgets/basiclistview.cpp
                ../../include/widgets/basiclistview.h
                ../../include/widgets/buttontuple.h
                widgets/comboboxwidget.cpp
                ../../include/widgets/comboboxwidget.h
                widgets/contentwidget.cpp
                ../../include/widgets/contentwidget.h
                widgets/editablenextpagewidget.cpp
                ../../include/widgets/editablenextpagewidget.h
                widgets/filechoosewidget.cpp
                ../../include/widgets/filechoosewidget.h
                ../../include/widgets/lineeditwidget.h
                ../../include/widgets/loadingnextpagewidget.h
                ../../include/widgets/nextbutton.h
                widgets/nextpagewidget.cpp
                ../../include/widgets/nextpagewidget.h
                widgets/optionitem.cpp
                ../../include/widgets/optionitem.h
                ../../include/widgets/optionlistpage.h
                ../../include/widgets/settingsgroup.h
                widgets/settingshead.cpp
                ../../include/widgets/settingshead.h
                ../../include/widgets/switchwidget.h
                widgets/themeitem.cpp
                ../../include/widgets/themeitem.h
                widgets/titledslideritem.cpp
                ../../include/widgets/titledslideritem.h
                widgets/timeoutdialog.cpp
                ../../include/widgets/timeoutdialog.h
                widgets/multiselectlistview.cpp
                ../../include/widgets/multiselectlistview.h
                widgets/powerdisplaywidget.cpp
                ../../include/widgets/powerdisplaywidget.h
                widgets/passwordedit.cpp
                ../../include/widgets/passwordedit.h
                widgets/detailinfoitem.cpp
                ../../include/widgets/detailinfoitem.h
                ../../include/widgets/securitylevelitem.h
                widgets/securitylevelitem.cpp
                widgets/widgets.qrc
)

# load modules
set(MODULE_FILES
)

# load authentatication
set(AUTHENTICATION_FILES
    modules/authentication/fingermodel.cpp
    modules/authentication/fingerworker.cpp
    modules/authentication/charamangermodel.cpp
    modules/authentication/charamangerworker.cpp
    modules/authentication/widgets/fingeritem.cpp
    modules/authentication/widgets/disclaimersitem.cpp
    modules/authentication/widgets/disclaimersdialog.cpp
    modules/authentication/widgets/fingerwidget.cpp
    modules/authentication/widgets/faceinfowidget.cpp
    window/modules/authentication/loginoptionsmodule.cpp
    window/modules/authentication/loginoptionswidget.cpp
    window/modules/authentication/fingerwidget.cpp
    window/modules/authentication/fingerdetailwidget.cpp
    window/modules/authentication/addfingedialog.cpp
    window/modules/authentication/faceiddetailwidget.cpp
    window/modules/authentication/facewidget.cpp
    window/modules/authentication/authenticationinfoitem.cpp
    window/modules/authentication/addfaceinfodialog.cpp
    window/modules/authentication/faceinfodialog.cpp
    # IRIS
    window/modules/authentication/irisdetailwidget.cpp
    window/modules/authentication/iriswidget.cpp
    window/modules/authentication/addirisinfodialog.cpp
    modules/authentication/widgets/irisinfowidget.cpp
    window/modules/authentication/fingedisclaimer.cpp
)

# load accounts
set(ACCOUNTS_FILES
                modules/accounts/creationresult.cpp
                modules/accounts/removeuserdialog.cpp
                modules/accounts/useroptionitem.cpp

=== tests/dde-control-center/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(dde-control-center-unittest C CXX)

set(BLUETOOTH_NAME bluetooth-unittest)
set(MOUSE_NAME mouse-unittest)
set(DATETIME_NAME datetime-unittest)
set(NOTIFICATION_NAME notification-unittest)
set(DEFAPP_NAME defapp-unittest)
set(SYSTEMINFO_NAME systeminfo-unittest)
set(KEYBOARD_NAME keyboard-unittest)

# 自动生成moc文件
set(CMAKE_AUTOMOC ON)

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

# Address Sanitizer 内存错误检测工具,打开下面的编译选项可以看到调试信息，正常运行时不需要这些信息
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2 -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
endif()

# 蓝牙模块源文件
file(GLOB_RECURSE BLUETOOTH_SRCS "bluetooth/*.cpp" "bluetooth/*.h")

#蓝牙模块依赖文件
file(GLOB_RECURSE BLUETOOTH_Tasks_SRCS
  ../../src/frame/modules/bluetooth/*.cpp

  ../../src/frame/window/modules/bluetooth/bluetoothwidget.cpp
  ../../src/frame/window/modules/bluetooth/adapterwidget.cpp
  ../../src/frame/window/modules/bluetooth/titleedit.cpp
  ../../src/frame/window/modules/bluetooth/devicesettingsitem.cpp
  ../../src/frame/window/modules/bluetooth/detailpage.cpp

  ../../src/frame/window/gsettingwatcher.cpp
  fakedbus/bluetooth_dbus.cpp
)

# 时间日期模块源文件
file(GLOB_RECURSE DATETIME_SRCS "datetime/*.cpp" "datetime/*.h")

# 时间日期模块依赖文件
file(GLOB_RECURSE DATETIME_Tasks_SRCS
    ../../src/frame/modules/datetime/datetimework.cpp
    ../../src/frame/modules/datetime/datetimemodel.cpp
    ../../src/frame/modules/datetime/timezoneitem.cpp
    ../../src/frame/modules/datetime/clock.cpp

    fakedbus/datetime_dbus.cpp
)

# 鼠标模块源文件
file(GLOB_RECURSE MOUSE_SRCS "mouse/*.cpp" "mouse/*.h")

# 鼠标模块依赖文件
file(GLOB_RECURSE MOUSE_Tasks_SRCS
  ../../src/frame/modules/mouse/mouseworker.cpp
  ../../src/frame/modules/mouse/mousemodel.cpp
  ../../src/frame/modules/mouse/doutestwidget.cpp
  ../../src/frame/modules/mouse/palmdetectsetting.cpp

  ../../src/frame/window/modules/mouse/mousewidget.cpp
  ../../src/frame/window/modules/mouse/generalsettingwidget.cpp
  ../../src/frame/window/modules/mouse/mousesettingwidget.cpp
  ../../src/frame/window/modules/mouse/touchpadsettingwidget.cpp
  ../../src/frame/window/modules/mouse/trackpointsettingwidget.cpp

  ../../src/frame/window/utils.h
  ../../src/frame/window/insertplugin.cpp
  ../../src/frame/window/gsettingwatcher.cpp
)

#通知模块源文件
file(GLOB_RECURSE NOTIFICATION_SRCS "notification/*.cpp" "notification/*.h")

#通知模块依赖文件
file(GLOB_RECURSE NOTIFICATION_Tasks_SRCS
  ../../src/frame/modules/notification/*.cpp
  ../../src/frame/window/gsettingwatcher.cpp
  ../../src/frame/window/modules/notification/notificationwidget.cpp
  ../../src/frame/window/modules/notification/appnotifywidget.cpp
  ../../src/frame/window/modules/notification/notificationitem.cpp
  ../../src/frame/window/modules/notification/systemnotifywidget.cpp
  ../../src/frame/window/modules/notification/timeslotitem.cpp

  fakedbus/notification_dbus.cpp
)

# 默认程序源文件
file(GLOB_RECURSE DEFAPP_SRCS "defapp/*.cpp" "defapp/*.h")

# 默认程序依赖文件
file(GLOB_RECURSE DEFAPP_Tasks_SRCS
  ../../src/frame/modules/defapp/defappworker.cpp
  ../../src/frame/modules/defapp/defappmodel.cpp
  ../../src/frame/modules/defapp/model/category.cpp
  ../../src/frame/window/gsettingwatcher.cpp
  ../../src/frame/window/insertplugin.cpp
  ../../src/frame/widgets/multiselectlistview.cpp

  ../../src/frame/window/modules/defapp/defappdetailwidget.cpp
  ../../src/frame/window/modules/defapp/defappwidget.cpp

  fakedbus/defapp_dbus.cpp
)

# 系统信息模块源文件
file(GLOB_RECURSE SYSTEMINFO_SRCS "systeminfo/*.cpp" "systeminfo/*.h")

# 系统信息依赖文件
file(GLOB_RECURSE SYSTEMINFO_Tasks_SRCS

   #../../src/frame/window/modules/systeminfo/*.cpp
   ../../src/frame/window/modules/systeminfo/privacypolicywidget.cpp
   ../../src/frame/window/modules/systeminfo/systeminfowidget.cpp
   ../../src/frame/window/modules/systeminfo/nativeinfowidget.cpp
   ../../src/frame/window/modules/systeminfo/userlicensewidget.cpp
   ../../src/frame/window/modules/systeminfo/versionprotocolwidget.cpp
   ../../src/frame/modules/systeminfo/*.cpp
   ../../src/frame/window/gsettingwatcher.cpp
   ../../src/frame/window/insertplugin.cpp
   ../../src/frame/window/utils.h
   ../../src/frame/window/protocolfile.cpp
)

# 键盘测试模块源文件
file(GLOB_RECURSE KEYBOARD_SRCS "keyboard/*.cpp")

# 头文件路径
set(KEYBOARD_HEADER
    ../../src/frame/window/modules/keyboard
    ../../src/frame/modules/keyboard
)

# 键盘测试依赖文件
file(GLOB_RECURSE KEYBOARD_Tasks_SRCS
    ../../src/frame/window/modules/keyboard/generalkbsettingwidget.cpp
    ../../src/frame/window/modules/keyboard/kblayoutsettingwidget.cpp
    ../../src/frame/window/modules/keyboard/systemlanguagewidget.cpp
    ../../src/frame/window/modules/keyboard/systemlanguagesettingwidget.cpp
    ../../src/frame/window/modules/keyboard/shortcutsettingwidget.cpp
    ../../src/frame/window/modules/keyboard/wayland-xwayland-keyboard-grab-v1-client-protocol.h
    ../../src/frame/window/modules/keyboard/wayland-xwayland-keyboard-grab-v1-protocol.c
    ../../src/frame/window/modules/keyboard/waylandgrab.cpp
    ../../src/frame/modules/keyboard/keyboardmodel.cpp
    ../../src/frame/modules/keyboard/indexmodel.cpp
    ../../src/frame/modules/keyboard/shortcutmodel.cpp
    ../../src/frame/modules/keyboard/shortcutitem.cpp
    ../../src/frame/modules/keyboard/shortcutkey.cpp
    ../../src/frame/window/gsettingwatcher.cpp
    ../../src/frame/modules/display/displaymodel.cpp
    ../../src/frame/modules/display/monitor.cpp
    ../../src/frame/modules/keyboard/keylabel.cpp
    ../../src/frame/window/utils.h
)

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

# 查找依赖库
find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS Widgets Test DBus WaylandClient REQUIRED Concurrent Svg)
find_package(DtkWidget REQUIRED)
find_package(GTest REQUIRED)
find_package(KF5Wayland QUIET)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

# 添加蓝牙模块执行文件信息
add_executable(${BLUETOOTH_NAME} ${BLUETOOTH_SRCS} ${BLUETOOTH_Tasks_SRCS})

# 添加时间日期模块执行文件信息
add_executable(${DATETIME_NAME} ${DATETIME_SRCS} ${DATETIME_Tasks_SRCS})

# 添加鼠标模块执行文件信息
add_executable(${MOUSE_NAME} ${MOUSE_SRCS} ${MOUSE_Tasks_SRCS})

# 添加通知模块执行文件信息
add_executable(${NOTIFICATION_NAME} ${NOTIFICATION_SRCS} ${NOTIFICATION_Tasks_SRCS})

# 添加默认程序模块执行文件信息
add_executable(${DEFAPP_NAME} ${DEFAPP_SRCS} ${DEFAPP_Tasks_SRCS})

# 添加系统信息模块执行文件信息
add_executable(${SYSTEMINFO_NAME} ${SYSTEMINFO_SRCS} ${SYSTEMINFO_Tasks_SRCS})

# 添加键盘模块执行文件信息
add_executable(${KEYBOARD_NAME} ${KEYBOARD_SRCS} ${KEYBOARD_Tasks_SRCS})

# 蓝牙模块链接库
target_link_libraries(${BLUETOOTH_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 蓝牙模块引用头文件
target_include_directories(${BLUETOOTH_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 时间日期模块链接库
target_link_libraries(${DATETIME_NAME} PUBLIC
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 时间日期模块引用头文件
target_include_directories(${DATETIME_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 鼠标模块链接库
target_link_libraries(${MOUSE_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 鼠标模块引用头文件
target_include_directories(${MOUSE_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 通知模块链接库
target_link_libraries(${NOTIFICATION_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 通知模块引用头文件
target_include_directories(${NOTIFICATION_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 默认程序模块链接库
target_link_libraries(${DEFAPP_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 默认程序模块引用头文件
target_include_directories(${DEFAPP_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 系统信息模块链接库
target_link_libraries(${SYSTEMINFO_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

find_package(PkgConfig REQUIRED)
pkg_check_modules(WaylandClient REQUIRED wayland-client)

# 键盘模块链接库
target_link_libraries(${KEYBOARD_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
    KF5::WaylandClient
    Qt5::WaylandClient
    ${WaylandClient_LIBRARIES}
)

# 系统信息模块引用头文件
target_include_directories(${SYSTEMINFO_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 键盘模块引用头文件
target_include_directories(${KEYBOARD_NAME} PUBLIC
    ${KEYBOARD_HEADER}
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5WaylandClient_PRIVATE_INCLUDE_DIRS}
)

add_custom_target(check
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tests/dde-control-center)

#'make check'命令依赖与我们的测试程序
add_dependencies(check ${BLUETOOTH_NAME} ${MOUSE_NAME} ${DATETIME_NAME} ${NOTIFICATION_NAME} ${DEFAPP_NAME} ${SYSTEMINFO_NAME} ${KEYBOARD_NAME})

include_directories(../../src/frame)
include_directories(fakedbus)

=== debian/changelog ===
dde-control-center (5.5.144-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Sat, 27 Aug 2022 10:33:18 +0800

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

export QT_SELECT = qt5
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_OPTIONS += nocheck
SYSTYPE=Desktop
SYSTYPE=$(shell cat /etc/deepin-version | grep Type= | awk -F'=' '{print $$2}')

%:
	dh $@ --parallel

ifeq ($(DEB_BUILD_ARCH), amd64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), x86_64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), mips64el)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), mipsel)
override_dh_auto_configure:
	dh_auto_configure -- \
		-DDCC_ENABLE_AUTOSTART=YES \
		-DDCC_DISABLE_OPACITY_ANIMATION=YES \
		-DDCC_KEEP_SETTINGS_LIVE=YES \
		-DDCC_DISABLE_MIRACAST=YES \
		-DDCC_DISABLE_GRUB=YES \
		-DDISABLE_SYS_UPDATE_MIRRORS=YES \
		-DDCC_DISABLE_LANGUAGE=YES -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), arm64)
override_dh_auto_configure:
	dh_auto_configure -- -DDISABLE_SYS_UPDATE_SOURCE_CHECK=YES \
		-DDISABLE_SYS_UPDATE_MIRRORS=YES -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), sw_64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), loongarch64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

## dde-control-center 5.5.149

=== abrecovery/CMakeLists.txt ===
--- 
+++ 
@@ -25,10 +25,6 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
 endif()
 
-# Install settings
-if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
-    set(CMAKE_INSTALL_PREFIX /usr)
-endif ()
 
 set(SRCS
     main.cpp
@@ -64,5 +60,5 @@
 )
 
 # bin
-install(TARGETS ${BIN_NAME} DESTINATION /usr/bin)
-install(FILES ${FILES_NAME} DESTINATION /etc/xdg/autostart)
+install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(FILES ${FILES_NAME} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

add_subdirectory("dccwidgets")
add_subdirectory("dde-control-center")

=== src/develop-tool/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION 4.0)

set(BIN_NAME develop-tool)

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
endif()

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()


if(NOT DEFINED DISABLE_SYS_UPDATE)

set(SRCS
        main.cpp
)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

add_executable(${BIN_NAME} ${SRCS})
target_include_directories(${BIN_NAME} PUBLIC
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt5Widgets_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
)

# bin
install(TARGETS ${BIN_NAME} DESTINATION lib/dde-control-center/)

endif()

=== src/frame/CMakeLists.txt ===
--- 
+++ 
@@ -26,10 +26,6 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
 endif()
 
-# Install settings
-if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
-    set(CMAKE_INSTALL_PREFIX /usr)
-endif ()
 
 set(DEFINED_LIST
 DISABLE_OPACITY_ANIMATION
@@ -305,3 +301,5 @@
                 modules/accounts/creationresult.cpp
                 modules/accounts/removeuserdialog.cpp
                 modules/accounts/useroptionitem.cpp
+                modules/accounts/accountsworker.cpp
+                modules/accounts/avatarwidget.cpp

=== src/reboot-reminder-dialog/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION 4.0)

set(BIN_NAME reboot-reminder-dialog)

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
endif()

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()


if(NOT DEFINED DISABLE_SYS_UPDATE)

set(SRCS
        main.cpp
        reminderdialog.h
        reminderdialog.cpp
)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

add_executable(${BIN_NAME} ${SRCS})
target_include_directories(${BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
)

# bin
install(TARGETS ${BIN_NAME} DESTINATION lib/dde-control-center/)

endif()

=== src/reset-password-dialog/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION 4.0)

set(BIN_NAME reset-password-dialog)
set(DEEPIN_PW_CHECK libdeepin_pw_check.so)

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
endif()

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()


if(NOT DEFINED DISABLE_SYS_UPDATE)

set(SRCS
        main.cpp
        utils.h
        resetpassworddialog.h
        resetpassworddialog.cpp
        securityquestionswidget.h
        securityquestionswidget.cpp
        unionidwidget.h
        unionidwidget.cpp
        passwordwidget.h
        passwordwidget.cpp
        resetpasswordworker.h
        resetpasswordworker.cpp
)

set(DCC_SRCS
    ../frame/widgets/securitylevelitem.cpp
    ../frame/window/modules/accounts/pwqualitymanager.cpp
    ../frame/window/utils.h
)

set(QRC resetpassworddialog.qrc)
# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS
    Widgets
    Concurrent
    DBus
    Svg
    Network
REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

add_executable(${BIN_NAME} ${SRCS} ${DCC_SRCS} ${QRC})
target_include_directories(${BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
    ../../include
    ../frame/window/modules/accounts/
    ../frame/
)

target_link_libraries(${BIN_NAME} PRIVATE
    dccwidgets
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DEEPIN_PW_CHECK}
    crypt
    ${LIBS}
)

# bin
install(TARGETS ${BIN_NAME} DESTINATION lib/dde-control-center/)

endif()

=== debian/changelog ===
dde-control-center (5.5.149-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Fri, 09 Sep 2022 13:36:02 +0800

=== debian/control ===
Source: dde-control-center
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:
 debhelper-compat (= 11),
 pkg-config,
 libx11-dev,
 cmake,
 qtbase5-dev,
 qtdeclarative5-dev,
 libqt5svg5-dev,
 libdtkcore-dev,
 libdtkwidget-dev,
 libdtkgui-dev,
 libdframeworkdbus-dev,
 libgsettings-qt-dev,
 qttools5-dev-tools,
 libdtkcore5-bin,
 qtbase5-private-dev,
 libxrandr-dev,
 libmtdev-dev,
 libfontconfig1-dev,
 libegl1-mesa-dev,
 libxcb-ewmh-dev,
 libudisks2-qt5-dev,
 qtmultimedia5-dev,
 deepin-desktop-base | deepin-desktop-server | deepin-desktop-device,
 libgtest-dev,
 libdeepin-pw-check-dev,
 libpolkit-qt5-1-dev,
 libdareader-dev,
 libqt5waylandclient5-dev,
 qtwayland5-private-dev,
 libkf5wayland-dev,
 libwayland-dev,
 libxkbcommon-dev
Standards-Version: 3.9.5
Homepage: https://github.com/linuxdeepin/dde-control-center

Package: dde-control-center
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${dist:Depends},
 dde-account-faces,
 dde-daemon,
 startdde,
 lastore-daemon,
 dde-api,
 xkb-data,
 deepin-installer-timezones,
 passwd,
 netselect,
 uos-license-content,
 libglib2.0-0,
 libdeepin-pw-check,
 deepin-desktop-schemas,
 libdframeworkdbus2,
 libdareader1,
 deepin-sync-daemon
Recommends:
 netselect,
 deepin-ab-recovery,
 deepin-recovery-plugin,
 dcc-network-plugin,
 dcc-deepinid-plugin
Suggests: redshift
Conflicts:
 dde-control-center-plugin-weather,
 dde-control-center-plugin-notify
Replaces:
 dde-control-center-plugin-weather,
 dde-control-center-plugin-notify
Description: New control center for Deepin Desktop Environment,
 Integrated control center with rich functions,Besides providing rich
 system setting items, the function level is simple, the logic is clear,
 the user can easily set the system, and the learning cost is low,
 Provide users with automatic update system and developer mode to meet
 the various needs of users for the operating system.
 abrecovery -restore system, Determine whether the system is restored
 reboot-reminder-dialog -Update restart, Confirm whether to restart the system
 after the completion of the update.
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-dev
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}, ${shlib:Depends}, ${dist:Depends}
Description: New control center for Deepin Desktop Environment - development files
 DDE Control Center is the control panel of Deepin Desktop Environment.

## dde-control-center 5.5.156

=== src/frame/CMakeLists.txt ===
--- 
+++ 
@@ -294,6 +294,7 @@
     window/modules/authentication/addirisinfodialog.cpp
     modules/authentication/widgets/irisinfowidget.cpp
     window/modules/authentication/fingedisclaimer.cpp
+    window/modules/authentication/biologicalbasedialog.cpp
 )
 
 # load accounts
@@ -302,4 +303,3 @@
                 modules/accounts/removeuserdialog.cpp
                 modules/accounts/useroptionitem.cpp
                 modules/accounts/accountsworker.cpp
-                modules/accounts/avatarwidget.cpp

=== debian/changelog ===
dde-control-center (5.5.156-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Thu, 13 Oct 2022 19:39:53 +0800

## dde-control-center 5.5.197

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(dde-control-center)

find_package(DtkCMake REQUIRED)
include(Dart)
include(CTest)

add_compile_definitions(CVERSION="${CVERSION}")

# Install settings
include(GNUInstallDirs)
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# Test architecture
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    # add compiler flags -mieee for mathmatic
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

set(STRONG_PASSWORD false)
set(AllowEnableMultiScaleRatio false)
set(AllowCloudSync true)
set(TESTING_SERVER "https://insider.deepin.org")

configure_file(files/dde-control-center.conf.in files/dde-control-center.conf @ONLY)

add_definitions(-DWINDOW_MODE)

add_subdirectory("src/frame")
add_subdirectory("src/reboot-reminder-dialog")
add_subdirectory("src/reset-password-dialog")
add_subdirectory("src/develop-tool")
add_subdirectory("tests")

if (NOT DEFINED DISABLE_RECOVERY)
    add_subdirectory("abrecovery")
endif()

file(GLOB DOCS_FILES "docs/*")
file(GLOB HEADERS "include/*")

## qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-control-center/translations)

#desktop
install(FILES dde-control-center.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(FILES dde-control-center-wapper DESTINATION ${CMAKE_INSTALL_BINDIR} PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

#schemas
install(FILES com.deepin.dde.control-center.gschema.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)

#dde-grand-search-daemon plugins
install(FILES com.deepin.dde-grand-search.dde-control-center-setting.conf DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE}/dde-grand-search-daemon/plugins/searcher)

#service
install(FILES com.deepin.dde.ControlCenter.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)

#docs
install(FILES ${DOCS_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dman/dde-control-center)

#datebases
install(FILES data/timezone.db DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-control-center)

# dict file
install(FILES data/MainEnglishDictionary_ProbWL.txt DESTINATION ${CMAKE_INSTALL_DATADIR}/dict)

# conf file
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/files/dde-control-center.conf DESTINATION ${CMAKE_INSTALL_DATADIR}/dde-control-center)

# polkit policy file
install(FILES com.deepin.controlcenter.develop.policy DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/actions)
if (OS_DEEPIN_PROFESSIONAL)
    if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
        install(FILES com.deepin.controlcenter.addomain.policy DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/actions)
    endif()
endif()

# dev files
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center)
install(DIRECTORY ${HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR})

include(CMakePackageConfigHelpers)
configure_package_config_file(DdeControlCenterConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
    PATH_VARS INCLUDE_INSTALL_DIR)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

=== src/develop-tool/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,7 @@
 find_package(PkgConfig REQUIRED)
 find_package(Qt5Widgets REQUIRED)
 find_package(Qt5DBus REQUIRED)
+find_package(DtkCore REQUIRED)
 
 pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
 
@@ -42,11 +43,13 @@
 target_include_directories(${BIN_NAME} PUBLIC
     ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
     ${PROJECT_BINARY_DIR}
+    ${DtkCore_INCLUDE_DIRS}
 )
 
 target_link_libraries(${BIN_NAME} PRIVATE
     ${Qt5Widgets_LIBRARIES}
     ${Qt5DBus_LIBRARIES}
+    ${DtkCore_LIBRARIES}
 )
 
 # bin

=== debian/changelog ===
dde-control-center (5.5.197-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Tue, 11 Apr 2023 10:43:33 +0800

dde-control-center (5.5.186) unstable; urgency=low

  * bump version to 5.5.186

-- yinjie <yinjie@uniontech.com>  Tue, 3 Jan 2023 16:04:21 +0000

=== debian/control ===
--- 
+++ 
@@ -34,7 +34,8 @@
  qtwayland5-private-dev,
  libkf5wayland-dev,
  libwayland-dev,
- libxkbcommon-dev
+ libxkbcommon-dev,
+ libdpkg-dev
 Standards-Version: 3.9.5
 Homepage: https://github.com/linuxdeepin/dde-control-center
